package role_admin

import (
	"context"
	"git.noahlan.cn/n-admin/n-admin-server/rpc/core/types/core"
	"github.com/jinzhu/copier"

	"git.noahlan.cn/n-admin/n-admin-server/api/internal/svc"
	"git.noahlan.cn/n-admin/n-admin-server/api/internal/types"

	"net/http"
)

type UpdateRoleAdminLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	r      *http.Request
}

func NewUpdateRoleAdminLogic(r *http.Request, ctx context.Context, svcCtx *svc.ServiceContext) *UpdateRoleAdminLogic {
	return &UpdateRoleAdminLogic{
		r:      r,
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *UpdateRoleAdminLogic) UpdateRoleAdmin(req *types.RoleInfo) error {
	var rpcReq core.RoleInfo
	_ = copier.Copy(&rpcReq, req)

	_, err := l.svcCtx.CoreRpc.UpdateRole(l.ctx, &rpcReq)
	if err != nil {
		return err
	}
	return nil
}
